
;CodeVisionAVR C Compiler V2.04.8a Standard
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8535
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Speed
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 128 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : No
;'char' is unsigned       : Yes
;8 bit enums              : No
;global 'const' stored in FLASH: Yes
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8535
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 512
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x025F
	.EQU __DSTACK_SIZE=0x0080
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _Menu=R4
	.DEF _Menu_1=R6
	.DEF _seringue=R8
	.DEF _Vtimer=R10
	.DEF __lcd_x=R13
	.DEF __lcd_y=R12

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer1_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_tbl10_G101:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G101:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0x3:
	.DB  0x54,0x45,0x52,0x55,0x4D,0x4F,0x0,0x42
	.DB  0x44,0x35,0x30,0x43,0x43,0x0,0x42,0x44
	.DB  0x32,0x30,0x43,0x43,0x0
_0x36:
	.DB  0x0,0x0,0x1,0x0,0x2,0x0
_0x0:
	.DB  0x54,0x50,0x33,0x2C,0x20,0x54,0x50,0x34
	.DB  0x20,0x50,0x53,0x20,0x43,0x6F,0x72,0x72
	.DB  0x0,0x2D,0x2D,0x2D,0x2D,0x2D,0x2D,0x2D
	.DB  0x2D,0x2D,0x2D,0x2D,0x2D,0x2D,0x2D,0x2D
	.DB  0x2D,0x0,0x45,0x54,0x52,0x3E,0x43,0x48
	.DB  0x5F,0x53,0x20,0x4F,0x4B,0x3E,0x52,0x47
	.DB  0x5F,0x44,0x0,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x53,0x45,0x54,0x3E
	.DB  0x52,0x55,0x4E,0x0,0x25,0x73,0x3D,0x20
	.DB  0x25,0x2D,0x75,0x25,0x2D,0x75,0x2E,0x25
	.DB  0x2D,0x75,0x6D,0x6C,0x2F,0x68,0x0,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x45,0x43,0x48
	.DB  0x41,0x50,0x3E,0x53,0x54,0x4F,0x50,0x0
	.DB  0x53,0x72,0x67,0x3D,0x54,0x45,0x52,0x55
	.DB  0x4D,0x4F,0x20,0x35,0x30,0x43,0x43,0x0
	.DB  0x53,0x72,0x67,0x3D,0x4D,0x4F,0x4E,0x4F
	.DB  0x2F,0x42,0x44,0x20,0x35,0x30,0x43,0x43
	.DB  0x0,0x53,0x65,0x72,0x69,0x6E,0x67,0x75
	.DB  0x65,0x3D,0x42,0x44,0x20,0x32,0x30,0x43
	.DB  0x43,0x0,0x45,0x43,0x48,0x50,0x3E,0x41
	.DB  0x72,0x72,0x20,0x4F,0x4B,0x3E,0x52,0x47
	.DB  0x5F,0x44,0x0,0x45,0x43,0x48,0x50,0x3E
	.DB  0x41,0x72,0x72,0x20,0x53,0x45,0x54,0x3E
	.DB  0x52,0x55,0x4E,0x0
_0x2000003:
	.DB  0x1
_0x2000000:
	.DB  0x49,0x3E,0x2B,0x20,0x44,0x3E,0x2D,0x20
	.DB  0x4F,0x3E,0x6D,0x6E,0x20,0x45,0x3E,0x53
	.DB  0x0,0x68,0x3A,0x20,0x25,0x2D,0x75,0x68
	.DB  0x2F,0x25,0x2D,0x75,0x6D,0x6E,0x2F,0x25
	.DB  0x2D,0x75,0x73,0x20,0x0,0x49,0x3E,0x2B
	.DB  0x20,0x44,0x3E,0x2D,0x20,0x4F,0x3E,0x4D
	.DB  0x20,0x45,0x3E,0x53,0x0,0x4A,0x3A,0x20
	.DB  0x25,0x2D,0x75,0x2F,0x25,0x2D,0x75,0x2F
	.DB  0x25,0x2D,0x69,0x0,0x49,0x3E,0x2B,0x20
	.DB  0x44,0x3E,0x2D,0x20,0x4F,0x3E,0x73,0x20
	.DB  0x45,0x3E,0x53,0x0,0x6D,0x6E,0x3A,0x20
	.DB  0x25,0x2D,0x75,0x68,0x2F,0x25,0x2D,0x75
	.DB  0x6D,0x6E,0x2F,0x25,0x2D,0x75,0x73,0x20
	.DB  0x0,0x49,0x3E,0x2B,0x20,0x44,0x3E,0x2D
	.DB  0x20,0x4F,0x3E,0x41,0x20,0x45,0x3E,0x53
	.DB  0x0,0x4D,0x3A,0x20,0x25,0x2D,0x75,0x2F
	.DB  0x25,0x2D,0x75,0x2F,0x25,0x2D,0x69,0x0
	.DB  0x49,0x3E,0x2B,0x20,0x44,0x3E,0x2D,0x20
	.DB  0x4F,0x3E,0x68,0x20,0x45,0x3E,0x53,0x0
	.DB  0x73,0x3A,0x20,0x25,0x2D,0x75,0x68,0x2F
	.DB  0x25,0x2D,0x75,0x6D,0x6E,0x2F,0x25,0x2D
	.DB  0x75,0x73,0x20,0x0,0x49,0x3E,0x2B,0x20
	.DB  0x44,0x3E,0x2D,0x20,0x4F,0x3E,0x4A,0x20
	.DB  0x45,0x3E,0x53,0x0,0x41,0x3A,0x20,0x25
	.DB  0x2D,0x75,0x2F,0x25,0x2D,0x75,0x2F,0x25
	.DB  0x2D,0x69,0x0,0x69,0x6E,0x63,0x2F,0x64
	.DB  0x65,0x63,0x3D,0x2B,0x2F,0x2D,0x20,0x2D
	.DB  0x3E,0x4F,0x6B,0x0,0x25,0x2D,0x75,0x25
	.DB  0x2D,0x75,0x2E,0x25,0x2D,0x75,0x20,0x6D
	.DB  0x6C,0x2F,0x68,0x20,0x2D,0x3E,0x45,0x4E
	.DB  0x54,0x52,0x0,0x31,0x2F,0x33,0x20,0x54
	.DB  0x45,0x52,0x55,0x4D,0x4F,0x20,0x35,0x30
	.DB  0x43,0x43,0x0,0x32,0x2F,0x33,0x20,0x4D
	.DB  0x4F,0x4E,0x2F,0x42,0x44,0x20,0x35,0x30
	.DB  0x43,0x43,0x0,0x33,0x2F,0x33,0x20,0x20
	.DB  0x20,0x20,0x20,0x42,0x44,0x20,0x32,0x30
	.DB  0x43,0x43,0x0,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x3F,0x3F,0x3F,0x3F,0x3F,0x3F
	.DB  0x3F,0x3F,0x0,0x25,0x2D,0x75,0x25,0x2D
	.DB  0x75,0x2E,0x25,0x2D,0x75,0x20,0x6D,0x6D
	.DB  0x2F,0x73,0x20,0x2D,0x3E,0x45,0x4E,0x54
	.DB  0x52,0x0,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x52,0x65,0x6E,0x74,0x72
	.DB  0x65,0x72,0x0,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x53,0x6F,0x72
	.DB  0x74,0x69,0x72,0x0
_0x2040003:
	.DB  0x80,0xC0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x06
	.DW  0x04
	.DW  _0x36*2

	.DW  0x01
	.DW  _Etat_BP_S1000000000
	.DW  _0x2000003*2

	.DW  0x02
	.DW  __base_y_G102
	.DW  _0x2040003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.04.5b Standard
;Automatic Program Generator
; Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project : Rorganisation de la commande du moteur
;pas  pas du Pousse Seringue (Correction TP3 et TP4)
;Version : 2     Rvision: 1
;Cr le : 26/10/2010
;Mise  jour    : 26/10/2010
;Author  : Philippe Mariano
;Company : SIPEM
;Comments: Choix de la seringue et rglage du dbit
; partir d'un clavier et d'un afficheur
;Chip type               : ATmega8535
;Program type            : Application
;AVR Core Clock frequency: 8,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 128
;*****************************************************/
;
;#include <mega8535.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;//-------------------------------------------------------------------------------------------------------
;// Librairies non gnres par Wizard (rajoutes manuellement)
;// -----------------------------------------------------------------------------------------------------
;#include "ssi2.h"     // Contient les fonctions Lire_BP, Affiche_LCD, Regdebit, Select_Seringue
;#include <delay.h>    // Contient la fonction delay_ms
;#include <stdio.h>    // Contient la fonction sprintf
;//-------------------------------------------------------------------------------------------------------
;//-------------------------------------------------------------------------------------------------------
;// Frquence du quartz prsent sur la carte SSI V1
;// -----------------------------------------------------------------------------------------------------
;#define FQUARTZ	    8E6
;//-------------------------------------------------------------------------------------------------------
;// Bus de commande du moteur
;// -----------------------------------------------------------------------------------------------------
;#define VPH 	    PORTB
;//-------------------------------------------------------------------------------------------------------
;// Alphanumeric LCD Module functions
;#asm
   .equ __lcd_port=0x15 ;PORTC
; 0000 002D #endasm
;#include <lcd.h>
;//-------------------------------------------------------------------------------------------------------
;// ------------------------------------------------------------------------------------------------------
;// Declare your global variables here
;//-------------------------------------------------------------------------------------------------------
;// type 	            nom              				    Description
;//-------------------------------------------------------------------------------------------------------
;char display_buffer_ligne0[17]; 						    // Tampon ligne 0 de l'afficheur LCD2x16
;char display_buffer_ligne1[17]; 						    // Tampon ligne 1 de l'afficheur LCD2x16
;enum EtatMenu{Arret, Marche, ReglageDebit, ChoixSeringue}   // Etats du graphe des transitions "Menu"
;			Menu=Arret, Menu_1=Marche;
;enum TypeSeringue{Terumo50CC,Monoject50CC,BD20CC}           // Seringue choisie
;            seringue = BD20CC;
;enum EtatMoteur{Etat0, Etat1, Etat2, Etat3} ; 	            // Etats du graphe des transitions "Moteur"
;unsigned int Vtimer; 							            // Rglage de la frquence de rotation du
;                                                            // moteur pas  pas
;//-------------------------------------------------------------------------------------------------------
;
;//-------------------------------------------------------------------------------------------------------
;// Timer 1 overflow interrupt service routine
;// Sous programme d'interruption: "Gnration des pas du moteur"
;interrupt [TIM1_OVF] void timer1_ovf_isr(void)
; 0000 0044 {

	.CSEG
_timer1_ovf_isr:
; 0000 0045     static unsigned char Etat = Etat0;
; 0000 0046     TCNT1 = Vtimer; // rechargement du timer 1
	__OUTWR 10,11,44
; 0000 0047     /*
; 0000 0048     switch(Etat)
; 0000 0049 	 {
; 0000 004A       case Etat0 : VPH = 6; Etat = Etat1; break;            // <- complter par les lves dans le TP3
; 0000 004B 	  			// <- complter par les lves dans le TP3
; 0000 004C 	              // <- complter par les lves dans le TP3
; 0000 004D 	             // <- complter par les lves dans le TP3
; 0000 004E 	 }
; 0000 004F      */
; 0000 0050 }
	RETI
;//-------------------------------------------------------------------------------------------------------
;
;// =====================================================================================================
;// Programme principal
;// =====================================================================================================
;void main(void)
; 0000 0057 {
_main:
; 0000 0058 // -----------------------------------------------------------------------------------------------------
; 0000 0059 // Declare your local variables here
; 0000 005A // -----------------------------------------------------------------------------------------------------
; 0000 005B // type 	                nom              				Description
; 0000 005C // -----------------------------------------------------------------------------------------------------
; 0000 005D char Type_Seringue[3][7]={"TERUMO","BD50CC","BD20CC"};
; 0000 005E unsigned int dizaines=0, unites=0, diziemes=0; 	// slection du dbit  dizaines unites.diziemes ml/h
; 0000 005F unsigned char BP;	 							// BP = code ou tat de la touche slectionne
; 0000 0060 float FPH; 										// frquence calcule  partir de la consigne de dbit
; 0000 0061 unsigned int dix_C_debit; 						// dix_C_debit = 100*dizaines + 10*unites + diziemes
; 0000 0062 // -----------------------------------------------------------------------------------------------------
; 0000 0063 
; 0000 0064 // Input/Output Ports initialization
; 0000 0065 // Port A initialization
; 0000 0066 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0067 // State7=T State6=T State5=P State4=P State3=P State2=P State1=P State0=P
; 0000 0068 PORTA=0x3F;
	SBIW R28,28
	LDI  R24,21
	LDI  R26,LOW(7)
	LDI  R27,HIGH(7)
	LDI  R30,LOW(_0x3*2)
	LDI  R31,HIGH(_0x3*2)
	RCALL __INITLOCB
;	Type_Seringue -> Y+7
;	dizaines -> R16,R17
;	unites -> R18,R19
;	diziemes -> R20,R21
;	BP -> Y+6
;	FPH -> Y+2
;	dix_C_debit -> Y+0
	__GETWRN 16,17,0
	__GETWRN 18,19,0
	__GETWRN 20,21,0
	LDI  R30,LOW(63)
	OUT  0x1B,R30
; 0000 0069 DDRA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1A,R30
; 0000 006A 
; 0000 006B // Port B initialization
; 0000 006C // Func7=In Func6=In Func5=In Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 006D // State7=T State6=T State5=T State4=0 State3=0 State2=0 State1=0 State0=0
; 0000 006E PORTB=0x00;
	OUT  0x18,R30
; 0000 006F DDRB=0x;                                      // <- complter par les lves dans le TP3
	OUT  0x17,R30
; 0000 0070 
; 0000 0071 // Timer/Counter 1 initialization
; 0000 0072 // Clock source: System Clock
; 0000 0073 // Clock value: 7,813 kHz
; 0000 0074 // Mode: Normal top=FFFFh
; 0000 0075 // OC1A output: Discon.
; 0000 0076 // OC1B output: Discon.
; 0000 0077 // Noise Canceler: Off
; 0000 0078 // Input Capture on Falling Edge
; 0000 0079 // Timer1 Overflow Interrupt: On
; 0000 007A // Input Capture Interrupt: Off
; 0000 007B // Compare A Match Interrupt: Off
; 0000 007C // Compare B Match Interrupt: Off
; 0000 007D TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 007E TCCR1B=0x05;
	LDI  R30,LOW(5)
	OUT  0x2E,R30
; 0000 007F TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
; 0000 0080 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 0081 ICR1H=0x00;
	OUT  0x27,R30
; 0000 0082 ICR1L=0x00;
	OUT  0x26,R30
; 0000 0083 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 0084 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 0085 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 0086 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 0087 
; 0000 0088 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 0089 TIMSK=0x00;
	OUT  0x39,R30
; 0000 008A 
; 0000 008B // LCD module initialization
; 0000 008C lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	RCALL _lcd_init
; 0000 008D 
; 0000 008E // -------------------------------------- Message d'accueil --------------------------------------------
; 0000 008F lcd_clear();
	RCALL _lcd_clear
; 0000 0090 sprintf(display_buffer_ligne0,"TP3, TP4 PS Corr");
	LDI  R30,LOW(_display_buffer_ligne0)
	LDI  R31,HIGH(_display_buffer_ligne0)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 0091 sprintf(display_buffer_ligne1,"----------------");
	LDI  R30,LOW(_display_buffer_ligne1)
	LDI  R31,HIGH(_display_buffer_ligne1)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,17
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 0092 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	LDI  R30,LOW(_display_buffer_ligne0)
	LDI  R31,HIGH(_display_buffer_ligne0)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_display_buffer_ligne1)
	LDI  R31,HIGH(_display_buffer_ligne1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Affiche_LCD
; 0000 0093 delay_ms(3000);
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0094 // -----------------------------------------------------------------------------------------------------
; 0000 0095 
; 0000 0096 while (1)
_0x4:
; 0000 0097       {
; 0000 0098       BP = Lire_BP();
	RCALL _Lire_BP
	STD  Y+6,R30
; 0000 0099 
; 0000 009A       switch (Menu)
	MOVW R30,R4
; 0000 009B       {
; 0000 009C         case Arret : if (Menu_1 != Menu)
	SBIW R30,0
	BREQ PC+2
	RJMP _0xA
	__CPWRR 4,5,6,7
	BREQ _0xB
; 0000 009D                        {
; 0000 009E                             PORTB = 0x00;  	// Dsactivation du moteur
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 009F                             TIMSK=0x00; 	// Inhibition interruption dbordement timer 1
	OUT  0x39,R30
; 0000 00A0                             #asm("cli")     // Global disnable interrupts
	cli
; 0000 00A1 
; 0000 00A2                             sprintf(display_buffer_ligne0,"ETR>CH_S OK>RG_D");
	LDI  R30,LOW(_display_buffer_ligne0)
	LDI  R31,HIGH(_display_buffer_ligne0)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,34
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 00A3                     	    sprintf(display_buffer_ligne1,"         SET>RUN");
	LDI  R30,LOW(_display_buffer_ligne1)
	LDI  R31,HIGH(_display_buffer_ligne1)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,51
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 00A4                     	    Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	LDI  R30,LOW(_display_buffer_ligne0)
	LDI  R31,HIGH(_display_buffer_ligne0)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_display_buffer_ligne1)
	LDI  R31,HIGH(_display_buffer_ligne1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Affiche_LCD
; 0000 00A5                        }
; 0000 00A6 
; 0000 00A7                        if (BP == OK) Menu = ReglageDebit;
_0xB:
	LDD  R26,Y+6
	CPI  R26,LOW(0x37)
	BRNE _0xC
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	MOVW R4,R30
; 0000 00A8                       		else if (BP == SET) Menu = Marche;
	RJMP _0xD
_0xC:
	LDD  R26,Y+6
	CPI  R26,LOW(0x3D)
	BRNE _0xE
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	MOVW R4,R30
; 0000 00A9                       	       		else if (BP == ENTR) Menu = ChoixSeringue;
	RJMP _0xF
_0xE:
	LDD  R26,Y+6
	CPI  R26,LOW(0x3E)
	BRNE _0x10
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	MOVW R4,R30
; 0000 00AA                       		               else Menu = Arret;
	RJMP _0x11
_0x10:
	CLR  R4
	CLR  R5
; 0000 00AB        		           Menu_1 = Arret;
_0x11:
_0xF:
_0xD:
	CLR  R6
	CLR  R7
; 0000 00AC         break;
	RJMP _0x9
; 0000 00AD 
; 0000 00AE         case Marche : if (Menu_1 != Menu)
_0xA:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x12
	__CPWRR 4,5,6,7
	BRNE PC+2
	RJMP _0x13
; 0000 00AF                        {
; 0000 00B0                           dix_C_debit = 100*dizaines + 10*unites + diziemes;
	__MULBNWRU 16,17,100
	MOVW R22,R30
	__MULBNWRU 18,19,10
	ADD  R30,R22
	ADC  R31,R23
	ADD  R30,R20
	ADC  R31,R21
	ST   Y,R30
	STD  Y+1,R31
; 0000 00B1 
; 0000 00B2                        	  switch (seringue)   // Calcul de FPH=f(C_debit)
	MOVW R30,R8
; 0000 00B3                          	{
; 0000 00B4                          	 case Terumo50CC : FPH = (0.2*dix_C_debit)/10; break;       // <- complter par les lves dans le TP4
	SBIW R30,0
	BRNE _0x17
	LD   R30,Y
	LDD  R31,Y+1
	CLR  R22
	CLR  R23
	RCALL __CDF1
	__GETD2N 0x3E4CCCCD
	RJMP _0x30
; 0000 00B5                           	 case Monoject50CC : FPH = (0.2396*dix_C_debit)/10; break;  // <- complter par les lves dans le TP4
_0x17:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x18
	LD   R30,Y
	LDD  R31,Y+1
	CLR  R22
	CLR  R23
	RCALL __CDF1
	__GETD2N 0x3E7559B4
	RJMP _0x30
; 0000 00B6                           	 case BD20CC : FPH = (0.4667*dix_C_debit)/10; break;        // <- complter par les lves dans le TP4
_0x18:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x16
	LD   R30,Y
	LDD  R31,Y+1
	CLR  R22
	CLR  R23
	RCALL __CDF1
	__GETD2N 0x3EEEF34D
_0x30:
	RCALL __MULF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x41200000
	RCALL __DIVF21
	__PUTD1S 2
; 0000 00B7                          	}
_0x16:
; 0000 00B8 
; 0000 00B9                           //calcul de la valeur initiale du timer1
; 0000 00BA                           Vtimer =  (unsigned int)(65536 - FQUARTZ/(4096*FPH)); 	    // <- complter par les lves dans le TP4
	__GETD1S 2
	__GETD2N 0x45800000
	RCALL __MULF12
	__GETD2N 0x4AF42400
	RCALL __DIVF21
	__GETD2N 0x47800000
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL __CFD1U
	MOVW R10,R30
; 0000 00BB 
; 0000 00BC                           TIMSK=0x04; // Autorisation interruption dbordement sur timer1
	LDI  R30,LOW(4)
	OUT  0x39,R30
; 0000 00BD                           #asm("sei") // Global enable interrupts
	sei
; 0000 00BE 
; 0000 00BF                           sprintf(display_buffer_ligne0,"%s= %-u%-u.%-uml/h",Type_Seringue[seringue],dizaines,unites,diziemes);
	LDI  R30,LOW(_display_buffer_ligne0)
	LDI  R31,HIGH(_display_buffer_ligne0)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,68
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R8
	LDI  R26,LOW(7)
	LDI  R27,HIGH(7)
	RCALL __MULW12U
	MOVW R26,R28
	ADIW R26,11
	ADD  R30,R26
	ADC  R31,R27
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	MOVW R30,R16
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	MOVW R30,R18
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	MOVW R30,R20
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,16
	RCALL _sprintf
	ADIW R28,20
; 0000 00C0                           sprintf(display_buffer_ligne1,"      ECHAP>STOP");
	LDI  R30,LOW(_display_buffer_ligne1)
	LDI  R31,HIGH(_display_buffer_ligne1)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,87
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 00C1                           Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	LDI  R30,LOW(_display_buffer_ligne0)
	LDI  R31,HIGH(_display_buffer_ligne0)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_display_buffer_ligne1)
	LDI  R31,HIGH(_display_buffer_ligne1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Affiche_LCD
; 0000 00C2 
; 0000 00C3                         }
; 0000 00C4 
; 0000 00C5        		            if (BP == ECHAP) Menu = Arret;
_0x13:
	LDD  R26,Y+6
	CPI  R26,LOW(0x3B)
	BRNE _0x1A
	CLR  R4
	CLR  R5
; 0000 00C6                       		    else Menu = Marche;
	RJMP _0x1B
_0x1A:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	MOVW R4,R30
; 0000 00C7 
; 0000 00C8                         Menu_1 = Marche;
_0x1B:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x31
; 0000 00C9         break;
; 0000 00CA 
; 0000 00CB         case ChoixSeringue: if (Menu_1 != Menu)
_0x12:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x1C
	__CPWRR 4,5,6,7
	BREQ _0x1D
; 0000 00CC                             {    #pragma warn-
; 0000 00CD                                	seringue = Menu_Select_Seringue();
	RCALL _Menu_Select_Seringue
	MOV  R8,R30
	CLR  R9
; 0000 00CE                                  #pragma warn-
; 0000 00CF                          	    switch(seringue)
	MOVW R30,R8
; 0000 00D0                          	    {
; 0000 00D1                          	        case Terumo50CC : sprintf(display_buffer_ligne0,"Srg=TERUMO 50CC"); break;
	SBIW R30,0
	BRNE _0x21
	LDI  R30,LOW(_display_buffer_ligne0)
	LDI  R31,HIGH(_display_buffer_ligne0)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,104
	RJMP _0x32
; 0000 00D2                          	        case Monoject50CC : sprintf(display_buffer_ligne0,"Srg=MONO/BD 50CC"); break;
_0x21:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x22
	LDI  R30,LOW(_display_buffer_ligne0)
	LDI  R31,HIGH(_display_buffer_ligne0)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,120
	RJMP _0x32
; 0000 00D3                          	        case BD20CC : sprintf(display_buffer_ligne0,"Seringue=BD 20CC"); break;
_0x22:
; 0000 00D4                                     default:  sprintf(display_buffer_ligne0,"Seringue=BD 20CC"); break;
_0x33:
	LDI  R30,LOW(_display_buffer_ligne0)
	LDI  R31,HIGH(_display_buffer_ligne0)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,137
_0x32:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 00D5                          	    }
; 0000 00D6 
; 0000 00D7                          	    sprintf(display_buffer_ligne1,"ECHP>Arr OK>RG_D");
	LDI  R30,LOW(_display_buffer_ligne1)
	LDI  R31,HIGH(_display_buffer_ligne1)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,154
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 00D8                          	    Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	LDI  R30,LOW(_display_buffer_ligne0)
	LDI  R31,HIGH(_display_buffer_ligne0)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_display_buffer_ligne1)
	LDI  R31,HIGH(_display_buffer_ligne1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Affiche_LCD
; 0000 00D9 
; 0000 00DA                             }
; 0000 00DB 
; 0000 00DC                             if (BP == ECHAP) Menu = Arret;
_0x1D:
	LDD  R26,Y+6
	CPI  R26,LOW(0x3B)
	BRNE _0x25
	CLR  R4
	CLR  R5
; 0000 00DD                       		    else if (BP == OK) Menu = ReglageDebit;
	RJMP _0x26
_0x25:
	LDD  R26,Y+6
	CPI  R26,LOW(0x37)
	BRNE _0x27
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0x34
; 0000 00DE                       		              else Menu = ChoixSeringue;
_0x27:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
_0x34:
	MOVW R4,R30
; 0000 00DF 
; 0000 00E0                             Menu_1 = ChoixSeringue;
_0x26:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RJMP _0x31
; 0000 00E1         break;
; 0000 00E2 
; 0000 00E3         case  ReglageDebit: if (Menu_1 != Menu)
_0x1C:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x9
	__CPWRR 4,5,6,7
	BRNE PC+2
	RJMP _0x2A
; 0000 00E4                             {
; 0000 00E5                                 Regdebit(&dizaines,&unites,&diziemes);
	IN   R30,SPL
	IN   R31,SPH
	SBIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	PUSH R17
	PUSH R16
	IN   R30,SPL
	IN   R31,SPH
	SBIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	PUSH R19
	PUSH R18
	IN   R30,SPL
	IN   R31,SPH
	SBIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	PUSH R21
	PUSH R20
	RCALL _Regdebit
	POP  R20
	POP  R21
	POP  R18
	POP  R19
	POP  R16
	POP  R17
; 0000 00E6                                 sprintf(display_buffer_ligne0,"%s= %-u%-u.%-uml/h",Type_Seringue[seringue],dizaines,unites,diziemes);
	LDI  R30,LOW(_display_buffer_ligne0)
	LDI  R31,HIGH(_display_buffer_ligne0)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,68
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R8
	LDI  R26,LOW(7)
	LDI  R27,HIGH(7)
	RCALL __MULW12U
	MOVW R26,R28
	ADIW R26,11
	ADD  R30,R26
	ADC  R31,R27
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	MOVW R30,R16
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	MOVW R30,R18
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	MOVW R30,R20
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,16
	RCALL _sprintf
	ADIW R28,20
; 0000 00E7                                 sprintf(display_buffer_ligne1,"ECHP>Arr SET>RUN");
	LDI  R30,LOW(_display_buffer_ligne1)
	LDI  R31,HIGH(_display_buffer_ligne1)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,171
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 00E8                                 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	LDI  R30,LOW(_display_buffer_ligne0)
	LDI  R31,HIGH(_display_buffer_ligne0)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_display_buffer_ligne1)
	LDI  R31,HIGH(_display_buffer_ligne1)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Affiche_LCD
; 0000 00E9                             }
; 0000 00EA                             if (BP == ECHAP) Menu = Arret;
_0x2A:
	LDD  R26,Y+6
	CPI  R26,LOW(0x3B)
	BRNE _0x2B
	CLR  R4
	CLR  R5
; 0000 00EB                       		    else if (BP == SET) Menu = Marche;
	RJMP _0x2C
_0x2B:
	LDD  R26,Y+6
	CPI  R26,LOW(0x3D)
	BRNE _0x2D
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x35
; 0000 00EC                       		               else Menu = ReglageDebit;
_0x2D:
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
_0x35:
	MOVW R4,R30
; 0000 00ED 
; 0000 00EE                           Menu_1 = ReglageDebit;
_0x2C:
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
_0x31:
	MOVW R6,R30
; 0000 00EF         break;
; 0000 00F0 
; 0000 00F1         };
_0x9:
; 0000 00F2 
; 0000 00F3       };
	RJMP _0x4
; 0000 00F4 }
_0x2F:
	RJMP _0x2F
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_Lire_BP:

	.DSEG

	.CSEG
	RCALL __SAVELOCR2
	IN   R30,0x19
	ANDI R30,LOW(0x3F)
	MOV  R16,R30
	LDS  R30,_Etat_BP_S1000000000
	LDS  R31,_Etat_BP_S1000000000+1
	SBIW R30,0
	BRNE _0x2000007
	CPI  R16,63
	BRNE _0x2000008
	MOV  R17,R16
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	IN   R30,0x19
	ANDI R30,LOW(0x3F)
	MOV  R16,R30
	CP   R16,R17
	BRNE _0x2000009
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _Etat_BP_S1000000000,R30
	STS  _Etat_BP_S1000000000+1,R31
	LDI  R30,LOW(255)
	RJMP _0x20E0005
_0x2000009:
	LDI  R30,LOW(0)
	RJMP _0x20E0005
_0x2000008:
	LDI  R30,LOW(0)
	RJMP _0x20E0005
_0x2000007:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x2000006
	CPI  R16,63
	BREQ _0x200000D
	MOV  R17,R16
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	ANDI R16,LOW(63)
	CP   R16,R17
	BRNE _0x200000E
	LDI  R30,LOW(0)
	STS  _Etat_BP_S1000000000,R30
	STS  _Etat_BP_S1000000000+1,R30
	MOV  R30,R16
	RJMP _0x20E0005
_0x200000E:
	LDI  R30,LOW(255)
	RJMP _0x20E0005
_0x200000D:
	LDI  R30,LOW(255)
_0x2000006:
_0x20E0005:
	RCALL __LOADLOCR2P
	RET
_Affiche_LCD:
	RCALL _lcd_clear
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _lcd_puts
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_gotoxy
	LD   R30,Y
	LDD  R31,Y+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _lcd_puts
	ADIW R28,4
	RET
_Regdebit:
	SBIW R28,38
	RCALL __SAVELOCR6
	LDI  R16,0
	LDI  R19,1
_0x2000068:
	RCALL _Lire_BP
	MOV  R17,R30
	MOV  R30,R16
	CPI  R30,0
	BREQ PC+2
	RJMP _0x200006E
	LDD  R26,Y+48
	LDD  R27,Y+48+1
	RCALL __GETW1P
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x200006F
	LDD  R26,Y+48
	LDD  R27,Y+48+1
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	RJMP _0x20000F5
_0x200006F:
	LDD  R26,Y+48
	LDD  R27,Y+48+1
	RCALL __GETW1P
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BRNE _0x2000071
	LDD  R26,Y+48
	LDD  R27,Y+48+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0x20000F5:
	ST   X+,R30
	ST   X,R31
_0x2000071:
	LDD  R26,Y+48
	LDD  R27,Y+48+1
	RCALL __GETW1P
	CP   R30,R20
	CPC  R31,R21
	BRNE _0x2000073
	CP   R16,R19
	BREQ _0x2000072
_0x2000073:
	MOVW R30,R28
	ADIW R30,23
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2000000,203
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2000000,220
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+52
	LDD  R27,Y+52+1
	RCALL __GETW1P
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDD  R26,Y+54
	LDD  R27,Y+54+1
	RCALL __GETW1P
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDD  R26,Y+56
	LDD  R27,Y+56+1
	RCALL __GETW1P
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,12
	RCALL _sprintf
	ADIW R28,16
	MOVW R30,R28
	ADIW R30,23
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,8
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Affiche_LCD
	LDD  R26,Y+48
	LDD  R27,Y+48+1
	LD   R20,X+
	LD   R21,X
_0x2000072:
	MOV  R30,R17
	CPI  R30,LOW(0x1F)
	BRNE _0x2000078
	LDD  R26,Y+48
	LDD  R27,Y+48+1
	RCALL __GETW1P
	ADIW R30,1
	ST   X+,R30
	ST   X,R31
	RJMP _0x2000077
_0x2000078:
	CPI  R30,LOW(0x2F)
	BRNE _0x2000079
	LDD  R26,Y+48
	LDD  R27,Y+48+1
	RCALL __GETW1P
	SBIW R30,1
	ST   X+,R30
	ST   X,R31
	RJMP _0x2000077
_0x2000079:
	CPI  R30,LOW(0x37)
	BRNE _0x200007A
	LDI  R16,LOW(1)
	RJMP _0x2000077
_0x200007A:
	CPI  R30,LOW(0x3E)
	BRNE _0x200007C
	LDI  R16,LOW(3)
	RJMP _0x2000077
_0x200007C:
	LDI  R16,LOW(0)
_0x2000077:
	LDI  R19,LOW(0)
	RJMP _0x200006D
_0x200006E:
	CPI  R30,LOW(0x1)
	BREQ PC+2
	RJMP _0x200007D
	LDD  R26,Y+46
	LDD  R27,Y+46+1
	RCALL __GETW1P
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x200007E
	LDD  R26,Y+46
	LDD  R27,Y+46+1
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	RJMP _0x20000F6
_0x200007E:
	LDD  R26,Y+46
	LDD  R27,Y+46+1
	RCALL __GETW1P
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BRNE _0x2000080
	LDD  R26,Y+46
	LDD  R27,Y+46+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0x20000F6:
	ST   X+,R30
	ST   X,R31
_0x2000080:
	LDD  R26,Y+46
	LDD  R27,Y+46+1
	RCALL __GETW1P
	LDD  R26,Y+42
	LDD  R27,Y+42+1
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x2000082
	CP   R16,R19
	BREQ _0x2000081
_0x2000082:
	MOVW R30,R28
	ADIW R30,23
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2000000,203
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2000000,220
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+52
	LDD  R27,Y+52+1
	RCALL __GETW1P
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDD  R26,Y+54
	LDD  R27,Y+54+1
	RCALL __GETW1P
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDD  R26,Y+56
	LDD  R27,Y+56+1
	RCALL __GETW1P
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,12
	RCALL _sprintf
	ADIW R28,16
	MOVW R30,R28
	ADIW R30,23
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,8
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Affiche_LCD
	LDD  R26,Y+46
	LDD  R27,Y+46+1
	RCALL __GETW1P
	STD  Y+42,R30
	STD  Y+42+1,R31
_0x2000081:
	MOV  R30,R17
	CPI  R30,LOW(0x1F)
	BRNE _0x2000087
	LDD  R26,Y+46
	LDD  R27,Y+46+1
	RCALL __GETW1P
	ADIW R30,1
	ST   X+,R30
	ST   X,R31
	RJMP _0x2000086
_0x2000087:
	CPI  R30,LOW(0x2F)
	BRNE _0x2000088
	LDD  R26,Y+46
	LDD  R27,Y+46+1
	RCALL __GETW1P
	SBIW R30,1
	ST   X+,R30
	ST   X,R31
	RJMP _0x2000086
_0x2000088:
	CPI  R30,LOW(0x37)
	BRNE _0x2000089
	LDI  R16,LOW(2)
	RJMP _0x2000086
_0x2000089:
	CPI  R30,LOW(0x3E)
	BRNE _0x200008B
	LDI  R16,LOW(3)
	RJMP _0x2000086
_0x200008B:
	LDI  R16,LOW(1)
_0x2000086:
	LDI  R19,LOW(1)
	RJMP _0x200006D
_0x200007D:
	CPI  R30,LOW(0x2)
	BREQ PC+2
	RJMP _0x200008C
	LDD  R26,Y+44
	LDD  R27,Y+44+1
	RCALL __GETW1P
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x200008D
	LDD  R26,Y+44
	LDD  R27,Y+44+1
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	RJMP _0x20000F7
_0x200008D:
	LDD  R26,Y+44
	LDD  R27,Y+44+1
	RCALL __GETW1P
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BRNE _0x200008F
	LDD  R26,Y+44
	LDD  R27,Y+44+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0x20000F7:
	ST   X+,R30
	ST   X,R31
_0x200008F:
	LDD  R26,Y+44
	LDD  R27,Y+44+1
	RCALL __GETW1P
	LDD  R26,Y+40
	LDD  R27,Y+40+1
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x2000091
	CP   R16,R19
	BREQ _0x2000090
_0x2000091:
	MOVW R30,R28
	ADIW R30,23
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2000000,203
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2000000,220
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+52
	LDD  R27,Y+52+1
	RCALL __GETW1P
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDD  R26,Y+54
	LDD  R27,Y+54+1
	RCALL __GETW1P
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDD  R26,Y+56
	LDD  R27,Y+56+1
	RCALL __GETW1P
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,12
	RCALL _sprintf
	ADIW R28,16
	MOVW R30,R28
	ADIW R30,23
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,8
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Affiche_LCD
	LDD  R26,Y+44
	LDD  R27,Y+44+1
	RCALL __GETW1P
	STD  Y+40,R30
	STD  Y+40+1,R31
_0x2000090:
	MOV  R30,R17
	CPI  R30,LOW(0x1F)
	BRNE _0x2000096
	LDD  R26,Y+44
	LDD  R27,Y+44+1
	RCALL __GETW1P
	ADIW R30,1
	ST   X+,R30
	ST   X,R31
	RJMP _0x2000095
_0x2000096:
	CPI  R30,LOW(0x2F)
	BRNE _0x2000097
	LDD  R26,Y+44
	LDD  R27,Y+44+1
	RCALL __GETW1P
	SBIW R30,1
	ST   X+,R30
	ST   X,R31
	RJMP _0x2000095
_0x2000097:
	CPI  R30,LOW(0x37)
	BRNE _0x2000098
	LDI  R16,LOW(0)
	RJMP _0x2000095
_0x2000098:
	CPI  R30,LOW(0x3E)
	BRNE _0x200009A
	LDI  R16,LOW(3)
	RJMP _0x2000095
_0x200009A:
	LDI  R16,LOW(2)
_0x2000095:
	LDI  R19,LOW(2)
	RJMP _0x200006D
_0x200008C:
	CPI  R30,LOW(0x3)
	BRNE _0x200006D
	LDI  R30,LOW(0)
	RJMP _0x20E0004
_0x200006D:
	RJMP _0x2000068
_0x20E0004:
	RCALL __LOADLOCR6
	ADIW R28,50
	RET
_Menu_Select_Seringue:
	SBIW R28,34
	RCALL __SAVELOCR6
	__GETWRN 18,19,2
	__GETWRN 20,21,1
	MOVW R30,R28
	ADIW R30,23
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2000000,203
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
_0x200009C:
	__CPWRR 18,19,20,21
	BREQ _0x200009F
	MOVW R30,R18
	SBIW R30,0
	BRNE _0x20000A3
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2000000,243
	RJMP _0x20000F8
_0x20000A3:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x20000A4
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2000000,259
	RJMP _0x20000F8
_0x20000A4:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x20000A6
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2000000,275
	RJMP _0x20000F8
_0x20000A6:
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2000000,291
_0x20000F8:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
	MOVW R30,R28
	ADIW R30,23
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,8
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Affiche_LCD
	MOVW R20,R18
_0x200009F:
	RCALL _Lire_BP
	MOV  R17,R30
	MOV  R30,R17
	CPI  R30,LOW(0x1F)
	BRNE _0x20000AA
	__ADDWRN 18,19,1
	__CPWRN 18,19,3
	BRLT _0x20000AB
	__GETWRN 18,19,0
_0x20000AB:
	RJMP _0x20000A9
_0x20000AA:
	CPI  R30,LOW(0x2F)
	BRNE _0x20000AC
	__SUBWRN 18,19,1
	TST  R19
	BRPL _0x20000AD
	__GETWRN 18,19,2
_0x20000AD:
	RJMP _0x20000A9
_0x20000AC:
	CPI  R30,LOW(0x37)
	BRNE _0x20000A9
	MOV  R30,R18
	RJMP _0x20E0003
_0x20000A9:
	RJMP _0x200009C
_0x20E0003:
	RCALL __LOADLOCR6
	ADIW R28,40
	RET
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_put_buff_G101:
	RCALL __SAVELOCR2
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	RCALL __GETW1P
	SBIW R30,0
	BREQ _0x2020010
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,4
	RCALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2020012
	__CPWRN 16,17,2
	BRLO _0x2020013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2020012:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL __GETW1P
	TST  R31
	BRMI _0x2020014
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
_0x2020014:
_0x2020013:
	RJMP _0x2020015
_0x2020010:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2020015:
	RCALL __LOADLOCR2
	ADIW R28,5
	RET
__print_G101:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2020016:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x2020018
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x202001C
	CPI  R18,37
	BRNE _0x202001D
	LDI  R17,LOW(1)
	RJMP _0x202001E
_0x202001D:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
_0x202001E:
	RJMP _0x202001B
_0x202001C:
	CPI  R30,LOW(0x1)
	BRNE _0x202001F
	CPI  R18,37
	BRNE _0x2020020
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RJMP _0x20200C9
_0x2020020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2020021
	LDI  R16,LOW(1)
	RJMP _0x202001B
_0x2020021:
	CPI  R18,43
	BRNE _0x2020022
	LDI  R20,LOW(43)
	RJMP _0x202001B
_0x2020022:
	CPI  R18,32
	BRNE _0x2020023
	LDI  R20,LOW(32)
	RJMP _0x202001B
_0x2020023:
	RJMP _0x2020024
_0x202001F:
	CPI  R30,LOW(0x2)
	BRNE _0x2020025
_0x2020024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2020026
	ORI  R16,LOW(128)
	RJMP _0x202001B
_0x2020026:
	RJMP _0x2020027
_0x2020025:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x202001B
_0x2020027:
	CPI  R18,48
	BRLO _0x202002A
	CPI  R18,58
	BRLO _0x202002B
_0x202002A:
	RJMP _0x2020029
_0x202002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x202001B
_0x2020029:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x202002F
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Z+4
	ST   -Y,R26
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RJMP _0x2020030
_0x202002F:
	CPI  R30,LOW(0x73)
	BRNE _0x2020032
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	RCALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strlen
	MOV  R17,R30
	RJMP _0x2020033
_0x2020032:
	CPI  R30,LOW(0x70)
	BRNE _0x2020035
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	RCALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2020033:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2020036
_0x2020035:
	CPI  R30,LOW(0x64)
	BREQ _0x2020039
	CPI  R30,LOW(0x69)
	BRNE _0x202003A
_0x2020039:
	ORI  R16,LOW(4)
	RJMP _0x202003B
_0x202003A:
	CPI  R30,LOW(0x75)
	BRNE _0x202003C
_0x202003B:
	LDI  R30,LOW(_tbl10_G101*2)
	LDI  R31,HIGH(_tbl10_G101*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x202003D
_0x202003C:
	CPI  R30,LOW(0x58)
	BRNE _0x202003F
	ORI  R16,LOW(8)
	RJMP _0x2020040
_0x202003F:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x2020071
_0x2020040:
	LDI  R30,LOW(_tbl16_G101*2)
	LDI  R31,HIGH(_tbl16_G101*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x202003D:
	SBRS R16,2
	RJMP _0x2020042
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2020043
	RCALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x2020043:
	CPI  R20,0
	BREQ _0x2020044
	SUBI R17,-LOW(1)
	RJMP _0x2020045
_0x2020044:
	ANDI R16,LOW(251)
_0x2020045:
	RJMP _0x2020046
_0x2020042:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x2020046:
_0x2020036:
	SBRC R16,0
	RJMP _0x2020047
_0x2020048:
	CP   R17,R21
	BRSH _0x202004A
	SBRS R16,7
	RJMP _0x202004B
	SBRS R16,2
	RJMP _0x202004C
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x202004D
_0x202004C:
	LDI  R18,LOW(48)
_0x202004D:
	RJMP _0x202004E
_0x202004B:
	LDI  R18,LOW(32)
_0x202004E:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	SUBI R21,LOW(1)
	RJMP _0x2020048
_0x202004A:
_0x2020047:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x202004F
_0x2020050:
	CPI  R19,0
	BREQ _0x2020052
	SBRS R16,3
	RJMP _0x2020053
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x2020054
_0x2020053:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2020054:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	CPI  R21,0
	BREQ _0x2020055
	SUBI R21,LOW(1)
_0x2020055:
	SUBI R19,LOW(1)
	RJMP _0x2020050
_0x2020052:
	RJMP _0x2020056
_0x202004F:
_0x2020058:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x202005A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x202005C
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x202005A
_0x202005C:
	CPI  R18,58
	BRLO _0x202005D
	SBRS R16,3
	RJMP _0x202005E
	SUBI R18,-LOW(7)
	RJMP _0x202005F
_0x202005E:
	SUBI R18,-LOW(39)
_0x202005F:
_0x202005D:
	SBRC R16,4
	RJMP _0x2020061
	CPI  R18,49
	BRSH _0x2020063
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2020062
_0x2020063:
	RJMP _0x20200CA
_0x2020062:
	CP   R21,R19
	BRLO _0x2020067
	SBRS R16,0
	RJMP _0x2020068
_0x2020067:
	RJMP _0x2020066
_0x2020068:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2020069
	LDI  R18,LOW(48)
_0x20200CA:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x202006A
	ANDI R16,LOW(251)
	ST   -Y,R20
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	CPI  R21,0
	BREQ _0x202006B
	SUBI R21,LOW(1)
_0x202006B:
_0x202006A:
_0x2020069:
_0x2020061:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	CPI  R21,0
	BREQ _0x202006C
	SUBI R21,LOW(1)
_0x202006C:
_0x2020066:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2020059
	RJMP _0x2020058
_0x2020059:
_0x2020056:
	SBRS R16,0
	RJMP _0x202006D
_0x202006E:
	CPI  R21,0
	BREQ _0x2020070
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RJMP _0x202006E
_0x2020070:
_0x202006D:
_0x2020071:
_0x2020030:
_0x20200C9:
	LDI  R17,LOW(0)
_0x202001B:
	RJMP _0x2020016
_0x2020018:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	RCALL __GETW1P
	RCALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	RCALL __SAVELOCR4
	MOVW R26,R28
	ADIW R26,12
	RCALL __ADDW2R15
	RCALL __GETW1P
	SBIW R30,0
	BRNE _0x2020072
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x20E0002
_0x2020072:
	MOVW R26,R28
	ADIW R26,6
	RCALL __ADDW2R15
	MOVW R16,R26
	MOVW R26,R28
	ADIW R26,12
	RCALL __ADDW2R15
	RCALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	RCALL __ADDW2R15
	RCALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G101)
	LDI  R31,HIGH(_put_buff_G101)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,10
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G101
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x20E0002:
	RCALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG

	.CSEG
__lcd_delay_G102:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
	RCALL __lcd_delay_G102
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G102
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G102
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G102
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G102:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G102
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G102
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf0 | (1<<__lcd_rs) | (1<<__lcd_rd) | (1<<__lcd_enable) ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G102
    ld    r26,y
    swap  r26
	RCALL __lcd_write_nibble_G102
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RJMP _0x20E0001
__lcd_read_nibble_G102:
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G102
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G102
    andi  r30,0xf0
	RET
_lcd_read_byte0_G102:
	RCALL __lcd_delay_G102
	RCALL __lcd_read_nibble_G102
    mov   r26,r30
	RCALL __lcd_read_nibble_G102
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G102)
	SBCI R31,HIGH(-__base_y_G102)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	ST   -Y,R30
	RCALL __lcd_write_data
	LDD  R13,Y+1
	LDD  R12,Y+0
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL __lcd_write_data
	RCALL __lcd_ready
	LDI  R30,LOW(12)
	ST   -Y,R30
	RCALL __lcd_write_data
	RCALL __lcd_ready
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(0)
	MOV  R12,R30
	MOV  R13,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	LDS  R30,__lcd_maxx
	CP   R13,R30
	BRLO _0x2040004
	__lcd_putchar1:
	INC  R12
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R12
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x2040004:
	INC  R13
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	RJMP _0x20E0001
_lcd_puts:
	ST   -Y,R17
_0x2040005:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2040007
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x2040005
_0x2040007:
	LDD  R17,Y+0
	ADIW R28,3
	RET
__long_delay_G102:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G102:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G102
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RJMP _0x20E0001
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G102,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G102,3
	RCALL __long_delay_G102
	LDI  R30,LOW(48)
	ST   -Y,R30
	RCALL __lcd_init_write_G102
	RCALL __long_delay_G102
	LDI  R30,LOW(48)
	ST   -Y,R30
	RCALL __lcd_init_write_G102
	RCALL __long_delay_G102
	LDI  R30,LOW(48)
	ST   -Y,R30
	RCALL __lcd_init_write_G102
	RCALL __long_delay_G102
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G102
	RCALL __long_delay_G102
	LDI  R30,LOW(40)
	ST   -Y,R30
	RCALL __lcd_write_data
	RCALL __long_delay_G102
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL __lcd_write_data
	RCALL __long_delay_G102
	LDI  R30,LOW(133)
	ST   -Y,R30
	RCALL __lcd_write_data
	RCALL __long_delay_G102
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RCALL _lcd_read_byte0_G102
	CPI  R30,LOW(0x5)
	BREQ _0x204000B
	LDI  R30,LOW(0)
	RJMP _0x20E0001
_0x204000B:
	RCALL __lcd_ready
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL __lcd_write_data
	RCALL _lcd_clear
	LDI  R30,LOW(1)
_0x20E0001:
	ADIW R28,1
	RET

	.CSEG

	.CSEG

	.CSEG
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.CSEG

	.DSEG
_display_buffer_ligne0:
	.BYTE 0x11
_display_buffer_ligne1:
	.BYTE 0x11
___rtc_status:
	.BYTE 0x1
_Etat_BP_S1000000000:
	.BYTE 0x2
__base_y_G102:
	.BYTE 0x4
__lcd_maxx:
	.BYTE 0x1

	.CSEG

	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF1211
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF1211:
	BRCC __ADDF128
	RJMP __ADDF129
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

__INITLOCB:
__INITLOCW:
	ADD  R26,R28
	ADC  R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
