
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb OCDR=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

unsigned char Lire_BP(void);

void Affiche_LCD(char *ligne0,char *ligne1);

unsigned char eeprom_read(unsigned char addcase, unsigned int adressmap);

void eeprom_write(unsigned char addcase, unsigned char adressmap, unsigned char data);

void eeprom_page_read(unsigned char addcase, unsigned int adressmap, unsigned char *display_buffer);

int RegleHTR(unsigned char AddPCF8583, unsigned char HeureOuDate, unsigned char HeureOuJour,
unsigned char MinutesOuMois, unsigned int SecondeOuAnnee);

unsigned char D2000_read(unsigned char adreemap);

void D2000_write(unsigned char adressmap, unsigned char data);

unsigned char Regdebit(unsigned int *dizaines,unsigned int *unites, unsigned int *diziemes);

unsigned char Menu_Select_Seringue(void);

unsigned int RegVitesse(unsigned int *unites,unsigned int *diziemes, unsigned int *centiemes);

unsigned char Menu_Select_Sens(void);

void ActiveTimer(void);

void DesactiveTimer(void);

#pragma used-

#pragma library ssi2.lib

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);
int printf(char flash *fmtstr,...);
int sprintf(char *str, char flash *fmtstr,...);
int vprintf(char flash * fmtstr, va_list argptr);
int vsprintf(char *str, char flash * fmtstr, va_list argptr);

char *gets(char *str,unsigned int len);
int snprintf(char *str, unsigned int size, char flash *fmtstr,...);
int vsnprintf(char *str, unsigned int size, char flash * fmtstr, va_list argptr);

int scanf(char flash *fmtstr,...);
int sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

#asm
   .equ __lcd_port=0x15 ;PORTC
#endasm

#pragma used+

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);

void lcd_write_byte(unsigned char addr, unsigned char data);

unsigned char lcd_read_byte(unsigned char addr);

void lcd_gotoxy(unsigned char x, unsigned char y);

void lcd_clear(void);
void lcd_putchar(char c);

void lcd_puts(char *str);

void lcd_putsf(char flash *str);

unsigned char lcd_init(unsigned char lcd_columns);

void lcd_control (unsigned char control);

#pragma used-
#pragma library lcd.lib

char display_buffer_ligne0[17]; 						    
char display_buffer_ligne1[17]; 						    
enum EtatMenu{Arret, Marche, ReglageDebit, ChoixSeringue}   
Menu=Arret, Menu_1=Marche;
enum TypeSeringue{Terumo50CC,Monoject50CC,BD20CC}           
seringue = BD20CC;
enum EtatMoteur{Etat0, Etat1, Etat2, Etat3} ; 	            
unsigned int Vtimer; 							            

interrupt [9] void timer1_ovf_isr(void)
{
static unsigned char Etat = Etat0;
TCNT1 = Vtimer; 

}

void main(void)
{

char Type_Seringue[3][7]={"TERUMO","BD50CC","BD20CC"};
unsigned int dizaines=0, unites=0, diziemes=0; 	
unsigned char BP;	 							
float FPH; 										
unsigned int dix_C_debit; 						

PORTA=0x3F;
DDRA=0x00;

PORTB=0x00;
DDRB=0x;                                      

TCCR1A=0x00;
TCCR1B=0x05;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

TIMSK=0x00;

lcd_init(16);

lcd_clear();
sprintf(display_buffer_ligne0,"TP3, TP4 PS Corr");
sprintf(display_buffer_ligne1,"----------------");
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
delay_ms(3000);

while (1)
{
BP = Lire_BP();

switch (Menu)
{
case Arret : if (Menu_1 != Menu)
{
PORTB = 0x00;  	
TIMSK=0x00; 	
#asm("cli")     

sprintf(display_buffer_ligne0,"ETR>CH_S OK>RG_D");
sprintf(display_buffer_ligne1,"         SET>RUN");
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
}

if (BP == 0b00110111		) Menu = ReglageDebit;
else if (BP == 0b00111101      ) Menu = Marche;
else if (BP == 0b00111110      ) Menu = ChoixSeringue;
else Menu = Arret;
Menu_1 = Arret;
break;

case Marche : if (Menu_1 != Menu)
{
dix_C_debit = 100*dizaines + 10*unites + diziemes;

switch (seringue)   
{
case Terumo50CC : FPH = (0.2*dix_C_debit)/10; break;       
case Monoject50CC : FPH = (0.2396*dix_C_debit)/10; break;  
case BD20CC : FPH = (0.4667*dix_C_debit)/10; break;        
}

Vtimer =  (unsigned int)(65536 - 8E6/(4096*FPH)); 	    

TIMSK=0x04; 
#asm("sei") 

sprintf(display_buffer_ligne0,"%s= %-u%-u.%-uml/h",Type_Seringue[seringue],dizaines,unites,diziemes);
sprintf(display_buffer_ligne1,"      ECHAP>STOP");
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);

}

if (BP == 0b00111011      ) Menu = Arret;
else Menu = Marche;

Menu_1 = Marche;
break;

case ChoixSeringue: if (Menu_1 != Menu)
{    #pragma warn-
seringue = Menu_Select_Seringue();
#pragma warn-
switch(seringue)
{
case Terumo50CC : sprintf(display_buffer_ligne0,"Srg=TERUMO 50CC"); break;
case Monoject50CC : sprintf(display_buffer_ligne0,"Srg=MONO/BD 50CC"); break;
case BD20CC : sprintf(display_buffer_ligne0,"Seringue=BD 20CC"); break;
default:  sprintf(display_buffer_ligne0,"Seringue=BD 20CC"); break;
}

sprintf(display_buffer_ligne1,"ECHP>Arr OK>RG_D");
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);

}

if (BP == 0b00111011      ) Menu = Arret;
else if (BP == 0b00110111		) Menu = ReglageDebit;
else Menu = ChoixSeringue;

Menu_1 = ChoixSeringue;
break;

case  ReglageDebit: if (Menu_1 != Menu)
{
Regdebit(&dizaines,&unites,&diziemes);
sprintf(display_buffer_ligne0,"%s= %-u%-u.%-uml/h",Type_Seringue[seringue],dizaines,unites,diziemes);
sprintf(display_buffer_ligne1,"ECHP>Arr SET>RUN");
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
}
if (BP == 0b00111011      ) Menu = Arret;
else if (BP == 0b00111101      ) Menu = Marche;
else Menu = ReglageDebit;

Menu_1 = ReglageDebit;
break;

};

};
}
